//
//  HomeVC.m
//  SampleApp
//
//  Created by Pokkt on 16/02/16.
//  Copyright © 2016 Pokkt. All rights reserved.
//

#import "HomeVC.h"
#import "AppDelegate.h"
#import <QuartzCore/QuartzCore.h>
#import "PokktManager.h"
#import "TestRewardedVC.h"

#import "PokktManager.h"
#import "AdDelegate.h"
#import "PokktConfig.h"
#import "MBProgressHUD.h"



#define EarnedPoints @"Points"
#define userDefaluts [NSUserDefaults standardUserDefaults]


@interface HomeVC ()<AdDelegate>

@property (nonatomic, strong) AppDelegate *appdelegate;
@property (nonatomic, strong) PokktConfig *pokktConfig;

@end

TestRewardedVC *rewarded ;

@implementation HomeVC

static NSString *className = @"HomeVC";

- (void)viewDidLoad
{
    [super viewDidLoad];

    [appIdTF setHidden:YES];
    [securityKeyTF setHidden:YES];
    [appIdLbl setHidden:YES];
    [securityLbl setHidden:YES];
    [settingBtn setSelected:NO];
    [self updateSubViewFrame];
    // Do any additional setup after loading the view from its nib.
    
    self.appdelegate = [UIApplication sharedApplication].delegate;
    [self setCornerRadius];
    
    UIDeviceOrientation  m_CurrentOrientation = [[UIDevice currentDevice] orientation];
    
    if (m_CurrentOrientation == UIDeviceOrientationLandscapeLeft
        || m_CurrentOrientation == UIDeviceOrientationLandscapeRight )
    {
        [scroll setContentSize:CGSizeMake(250, 400)];
    }
    [[UIDevice currentDevice] beginGeneratingDeviceOrientationNotifications];
    
    [[NSNotificationCenter defaultCenter] addObserver: self selector: @selector(deviceOrientationDidChange:) name: UIDeviceOrientationDidChangeNotification object: nil];
    
    [NSTimer scheduledTimerWithTimeInterval:0.2
                                     target:self
                                   selector:@selector(targetMethod)
                                   userInfo:nil
                                    repeats:YES];
}

-(void)targetMethod
{
    [testRewarded setShowsTouchWhenHighlighted:YES];
}

- (void)viewDidAppear:(BOOL)animated
{
    
}

- (void)viewWillAppear:(BOOL)animated
{
    [super viewWillAppear:animated];
}

- (void)didReceiveMemoryWarning
{
    [super didReceiveMemoryWarning];
    // Dispose of any resources that can be recreated.
}

#pragma mark - Orienation

- (UIInterfaceOrientationMask)supportedInterfaceOrientations
{
    if (self.appdelegate.deviceType == iPhone4s || self.appdelegate.deviceType == iPhone5 || self.appdelegate.deviceType == iPhone5s) {
        return UIInterfaceOrientationMaskPortrait;
    }
    return UIInterfaceOrientationMaskAll;
}

- (void)deviceOrientationDidChange:(NSNotification *)notification

{
    UIDeviceOrientation  m_CurrentOrientation = [[UIDevice currentDevice] orientation];
    if (m_CurrentOrientation == UIDeviceOrientationLandscapeLeft || m_CurrentOrientation == UIDeviceOrientationLandscapeRight ) {
        [scroll setContentSize:CGSizeMake(250, 400)];
    }
    else if (m_CurrentOrientation == UIDeviceOrientationPortrait || m_CurrentOrientation == UIDeviceOrientationPortraitUpsideDown)
    {
        [scroll setContentSize:CGSizeMake(250, 200)];
    }
    
}

-(void)setCornerRadius
{
    initializeSdkBtn.layer.cornerRadius = 10; // this value vary as per your desire
    initializeSdkBtn.clipsToBounds = YES;

    testNonRewarded.layer.cornerRadius = 10; // this value vary as per your desire
    testNonRewarded.clipsToBounds = YES;
    
    testRewarded.layer.cornerRadius = 10; // this value vary as per your desire
    testRewarded.clipsToBounds = YES;
    
    exportLog.layer.cornerRadius = 10; // this value vary as per your desire
    exportLog.clipsToBounds = YES;
}

-(IBAction)settingAction:(id)sender
{
    if (settingBtn.selected) {
        [settingBtn setSelected:NO];
    }
    else
    {
        [settingBtn setSelected:YES];
    }
    
    [self updateSubViewFrame];

}



-(void)updateSubViewFrame
{
  if (!settingBtn.selected)
  {
      [UIView animateWithDuration:0.3 delay:0 options:UIViewAnimationOptionAllowAnimatedContent animations:^{
          
          [appIdTF setHidden:YES];
          [securityKeyTF setHidden:YES];
          [appIdLbl setHidden:YES];
          [securityLbl setHidden:YES];
          
      } completion:^(BOOL finished) {
          
          CGRect screeTF = screenNameTF.frame;
          screeTF.origin.y = appIdTF.frame.origin.y;
          screenNameTF.frame = screeTF;
          
          CGRect initB = initializeSdkBtn.frame;
          initB.origin.y = screenNameTF.frame.origin.y + screenNameTF.frame.size.height +8;
          initializeSdkBtn.frame = initB;

          CGRect nonRB = testNonRewarded.frame;
          nonRB.origin.y = initializeSdkBtn.frame.origin.y + initializeSdkBtn.frame.size.height +8;
          testNonRewarded.frame = nonRB;
          
          CGRect RB = testRewarded.frame;
          RB.origin.y = testNonRewarded.frame.origin.y + testNonRewarded.frame.size.height +8;
          testRewarded.frame = RB;
          
          CGRect exportB = exportLog.frame;
          exportB.origin.y = testRewarded.frame.origin.y + testRewarded.frame.size.height + 8;
          exportLog.frame = exportB;

      }];
     
  }
  else
  {
      [UIView animateWithDuration:0.3 delay:0 options:UIViewAnimationOptionAllowAnimatedContent animations:^{
          CGRect screeTF = screenNameTF.frame;
          screeTF.origin.y = securityKeyTF.frame.origin.y + securityKeyTF.frame.size.height +8;
          screenNameTF.frame = screeTF;
          
          CGRect initB = initializeSdkBtn.frame;
          initB.origin.y = screenNameTF.frame.origin.y + screenNameTF.frame.size.height +8;
          initializeSdkBtn.frame = initB;
          
          CGRect nonRB = testNonRewarded.frame;
          nonRB.origin.y = initializeSdkBtn.frame.origin.y + initializeSdkBtn.frame.size.height +8;
          testNonRewarded.frame = nonRB;
          
          CGRect RB = testRewarded.frame;
          RB.origin.y = testNonRewarded.frame.origin.y + testNonRewarded.frame.size.height +8;
          testRewarded.frame = RB;
          
          CGRect exportB = exportLog.frame;
          exportB.origin.y = testRewarded.frame.origin.y + testRewarded.frame.size.height +8;
          exportLog.frame = exportB;
          
      } completion:^(BOOL finished) {
          
          [appIdTF setHidden:NO];
          [securityKeyTF setHidden:NO];
          [appIdLbl setHidden:NO];
          [securityLbl setHidden:NO];
      }];
    
  }
}

-(IBAction)testAd:(id)sender
{
    if (isPokktInitialize) {
    UIButton *btn = (UIButton *)sender;
    rewarded = [[TestRewardedVC alloc] initWithNibName:@"TestRewardedVC" bundle:nil];
    rewarded.screenName = screenNameTF.text;

    if (btn.tag == 101)
    {
        if (screenNameTF.text.length > 0) {
            rewarded.isRewardedScreen = NO;
            [self.navigationController pushViewController:rewarded animated:YES];
        }
        else
        {
            [self showAlertWithMessage:@"Please Enter Screen Name or Zone ID"];
        }
  
    }
    else if (btn.tag == 102)
    {
        if (screenNameTF.text.length > 0) {
             rewarded.isRewardedScreen = YES;
            [self.navigationController pushViewController:rewarded animated:YES];
        }
        else
        {
            [self showAlertWithMessage:@"Please Enter Screen Name or Zone ID"];
        }
    }
    else if (btn.tag == 103)
    {
      [PokktManager exportLog:self];
    }
    }
    else
    {
      [self showAlertWithMessage:@"Pokkt sdk is not initialized."];
    }
}

- (void)showAlertWithMessage:(NSString *)msg {
    
    UIAlertView *alert = [[UIAlertView alloc]initWithTitle:@"" message:msg delegate:nil cancelButtonTitle:@"OK" otherButtonTitles:nil];
    [alert show];
}

- (BOOL)textFieldShouldReturn:(UITextField *)textField
{
    [textField resignFirstResponder];
    return YES;
}


-(IBAction)initialisePokktSDK:(id)sender;
{
    if (isPokktInitialize) {
        return;
    }
   
    [MBProgressHUD showHUDAddedTo:self.view animated:YES];
    self.pokktConfig  = [[PokktConfig alloc]init];
    self.pokktConfig.applicationId = appIdTF.text;
    self.pokktConfig.securityKey = securityKeyTF.text;
        
    self.pokktConfig.thirdPartyUserId = @"123456";
    
    [PokktManager setDebug: YES];
    [PokktManager initPokkt:self.pokktConfig withDelegate:self];
    
}


#pragma mark - Pokkt Delegates

- (void)onPokktInitialised:(BOOL)isReady
{

    [rewarded onPokktInitialised:isReady];
    if (isReady)
    {
        isPokktInitialize = YES;
        NSLog(@"PokktSDK is ready");
    }
    else
    { 
        isPokktInitialize = NO;
        NSLog(@"PokktSDK is not ready");
        [self showAlertWithMessage:@"PokktSDK is not ready"];
    }
    
    [MBProgressHUD hideAllHUDsForView:self.view animated:YES];
}

- (void)onAdAvailabilityStatus:(AdConfig *)adConfig withAvailability:(BOOL)isAdAvailable
{
   [rewarded onAdAvailabilityStatus:adConfig withAvailability:isAdAvailable];
}

- (void)onAdCachingCompleted:(AdConfig *)adConfig withReward:(float)reward
{
    [rewarded onAdCachingCompleted:adConfig withReward:reward];
}

- (void)onAdCachingFailed:(AdConfig *)adConfig withErrorMessage:(NSString *)errorMessage
{
    [rewarded onAdCachingFailed:adConfig withErrorMessage:errorMessage];
}

- (void)onAdClosed: (AdConfig *)adConfig
{
    [rewarded onAdClosed:adConfig];
}

- (void)onAdCompleted: (AdConfig *)adConfig
{
    [rewarded onAdCompleted:adConfig];

}

- (void)onAdDisplayed:(AdConfig *)adConfig
{
    [rewarded onAdDisplayed:adConfig];
}

- (void)onAdGratified:(AdConfig *)adConfig withReward:(float)reward
{
    [rewarded onAdGratified:adConfig withReward:reward];
}

- (void)onAdSkipped:(AdConfig *)adConfig
{
    [rewarded onAdSkipped:adConfig];
}


@end
