//
//  HomeVC.swift
//  SwiftSample
//
//  Created by Pokkt on 21/03/16.
//  Copyright © 2016 Pokkt. All rights reserved.
//

import Foundation
import UIKit
import SystemConfiguration

class HomeVC: UIViewController , AdDelegate,UITextFieldDelegate
{
    
    let className : String = ""
    @IBOutlet  var screenNameTF: UITextField?
    @IBOutlet  var appIdTF: UITextField?
    @IBOutlet  var securityKeyTF: UITextField?
    
    @IBOutlet  var testRewarded: UIButton?
    @IBOutlet  var testNonRewarded: UIButton?
    @IBOutlet  var settingBtn: UIButton?
    
    @IBOutlet  var exportLog: UIButton?
    @IBOutlet  var initializeSdkBtn: UIButton?
    
    @IBOutlet  var scroll: UIScrollView?
    @IBOutlet  var appIdLbl: UILabel?
    @IBOutlet  var securityLbl: UILabel?
    
    var keyboardIsShown: Bool = false
    var isPokktInitialize: Bool = false
    
    let appDelegate = UIApplication.sharedApplication().delegate as! AppDelegate;
    let pokktConfig:PokktConfig = PokktConfig()
    let testAdVC = TestRewardedVC(nibName: "TestRewardedVC", bundle: nil)
    
    
    override func viewDidLoad() {
        super.viewDidLoad()
        appIdTF?.hidden=true
        securityKeyTF?.hidden=true
        
        appIdLbl?.hidden=true
        securityLbl?.hidden=true
        
        settingBtn?.selected=false
        updateSubViewFrame()
        setCornerRadius()
        // Do any additional setup after loading the view.
    }
    
    override func viewWillAppear(animated: Bool) {
        
        scroll!.contentSize = CGSizeMake(250, 600);
    }
    
    override func didReceiveMemoryWarning() {
        super.didReceiveMemoryWarning()
        // Dispose of any resources that can be recreated.
    }
    
    override func supportedInterfaceOrientations() -> UIInterfaceOrientationMask {
        if(self.appDelegate.deviceType == DeviceType.iPhone4s || self.appDelegate.deviceType == DeviceType.iPhone5 || self.appDelegate.deviceType == DeviceType.iPhone5s){
            return UIInterfaceOrientationMask.Portrait
        }
        return UIInterfaceOrientationMask.All
    }
    
    @IBAction func changeSetting(sender: UIButton) {
        
        if((settingBtn?.selected) != nil)
        {
            if(settingBtn!.selected)
            {
                settingBtn?.selected = false
            }
            else
            {
                settingBtn?.selected = true
            }
        }
        
        updateSubViewFrame()
        
    }
    
    @IBAction func testAd(sender: UIButton)
    {
        if(isPokktInitialize)
        {
            if(sender.tag == 101)
            {
               if(screenNameTF?.text != nil && screenNameTF?.text != "")
               {
                testAdVC.isReward = false
                testAdVC.screenName = screenNameTF?.text
                self.navigationController!.pushViewController(testAdVC, animated: true)
               }
               else
               {
                showAlertWithMessage("Please Enter Screen Name or Zone ID")
               }
            }
            else if (sender.tag == 102)
            {
                if(screenNameTF?.text != nil && screenNameTF?.text != "")
                {
                testAdVC.isReward = true
                testAdVC.screenName = screenNameTF?.text
                self.navigationController!.pushViewController(testAdVC, animated: true)
                }
                else
                {
                    showAlertWithMessage("Please Enter Screen Name or Zone ID")
                }
            }
            else if (sender.tag == 103)
            {
                PokktManager.exportLog(self)
            }
        }
        else
        {
            
            showAlertWithMessage("Pokkt sdk is not initialized.")
        }
        
    }
    
    @IBAction func initialisePokktSDK(sender: UIButton)
    {
        if (isPokktInitialize) {
            return;
        }
        
        MBProgressHUD.showHUDAddedTo(self.view, animated: true)
        self.pokktConfig.applicationId = appIdTF?.text;
        self.pokktConfig.securityKey = securityKeyTF?.text;
        self.pokktConfig.thirdPartyUserId = "123456";
        
        PokktManager.setDebug(true)
        PokktManager.initPokkt(self.pokktConfig, withDelegate: self)
        
    }
    
    
    
    
    func setCornerRadius()
    {
        initializeSdkBtn?.layer.cornerRadius = 10; // this value vary as per your desire
        initializeSdkBtn?.clipsToBounds = true;
        
        testNonRewarded?.layer.cornerRadius = 10; // this value vary as per your desire
        testNonRewarded?.clipsToBounds = true;
        
        testRewarded?.layer.cornerRadius = 10; // this value vary as per your desire
        testRewarded?.clipsToBounds = true;
        
        exportLog?.layer.cornerRadius = 10; // this value vary as per your desire
        exportLog?.clipsToBounds = true;
    }
    
    
    
    func updateSubViewFrame()
    {
        if((settingBtn?.selected) != nil)
        {
            if(!settingBtn!.selected)
            {
                UIView.animateWithDuration(0.2, animations: {
                    self.appIdTF?.hidden=true
                    self.securityKeyTF?.hidden=true
                    
                    self.appIdLbl?.hidden=true
                    self.securityLbl?.hidden=true
                    }, completion: {
                        (value: Bool) in
                        var screenTF :CGRect = (self.screenNameTF?.frame)!
                        screenTF.origin.y = (self.appIdTF?.frame.origin.y)!
                        self.screenNameTF?.frame = screenTF
                        
                        var initB :CGRect = (self.initializeSdkBtn?.frame)!
                        initB.origin.y = (self.screenNameTF?.frame.origin.y)! + (self.screenNameTF?.frame.size.height)! + 8
                        self.initializeSdkBtn?.frame = initB
                        
                        var nonRB :CGRect = (self.testNonRewarded?.frame)!
                        nonRB.origin.y = (self.initializeSdkBtn?.frame.origin.y)! + (self.initializeSdkBtn?.frame.size.height)! + 8
                        self.testNonRewarded?.frame = nonRB
                        
                        var RB :CGRect = (self.testRewarded?.frame)!
                        RB.origin.y = (self.testNonRewarded?.frame.origin.y)! + (self.testNonRewarded?.frame.size.height)! + 8
                        self.testRewarded?.frame = RB
                        
                        var exportB :CGRect = (self.exportLog?.frame)!
                        exportB.origin.y = (self.testRewarded?.frame.origin.y)! + (self.testRewarded?.frame.size.height)! + 8
                        self.exportLog?.frame = exportB
                        
                        
                })
            }
            else
            {
                UIView.animateWithDuration(0.2, animations: {
                    
                    var screenTF :CGRect = (self.screenNameTF?.frame)!
                    screenTF.origin.y = (self.securityKeyTF?.frame.origin.y)! + (self.securityKeyTF?.frame.size.height)! + 8
                    self.screenNameTF?.frame = screenTF
                    
                    var initB :CGRect = (self.initializeSdkBtn?.frame)!
                    initB.origin.y = (self.screenNameTF?.frame.origin.y)! + (self.screenNameTF?.frame.size.height)! + 8
                    self.initializeSdkBtn?.frame = initB
                    
                    var nonRB :CGRect = (self.testNonRewarded?.frame)!
                    nonRB.origin.y = (self.initializeSdkBtn?.frame.origin.y)! + (self.initializeSdkBtn?.frame.size.height)! + 8
                    self.testNonRewarded?.frame = nonRB
                    
                    var RB :CGRect = (self.testRewarded?.frame)!
                    RB.origin.y = (self.testNonRewarded?.frame.origin.y)! + (self.testNonRewarded?.frame.size.height)! + 8
                    self.testRewarded?.frame = RB
                    
                    var exportB :CGRect = (self.exportLog?.frame)!
                    exportB.origin.y = (self.testRewarded?.frame.origin.y)! + (self.testRewarded?.frame.size.height)! + 8
                    self.exportLog?.frame = exportB
                    
                    }, completion: {
                        (value: Bool) in
                        
                        self.appIdTF?.hidden=false
                        self.securityKeyTF?.hidden=false
                        
                        self.appIdLbl?.hidden=false
                        self.securityLbl?.hidden=false
                        
                })
                
            }
        }
    }
    
    
    func onPokktInitialised(isReady:Bool)
    {
        var msg: String
        testAdVC.onPokktInitialised(isReady)
        if (isReady)
        {
            msg = "PokktSDK is ready";
            isPokktInitialize = true
        }
        else
        {
            msg = "PokktSDK is not ready";
            showAlertWithMessage(msg)
        }
        
        MBProgressHUD.hideAllHUDsForView(self.view, animated: true)
        
        
    }
    
    func onAdCachingCompleted(adConfig: AdConfig, withReward reward: Float)
    {
        testAdVC.onAdCachingCompleted(adConfig, withReward: reward)
    }
    
    func onAdCachingFailed(adConfig: AdConfig, withErrorMessage errorMessage: String)
    {
        testAdVC.onAdCachingFailed(adConfig, withErrorMessage: errorMessage)
    }
    
    
    func onAdCompleted(adConfig: AdConfig)
    {
        testAdVC.onAdCompleted(adConfig)
    }
    
    
    func onAdDisplayed(adConfig:AdConfig)
    {
        testAdVC.onAdDisplayed(adConfig)
    }
    
    
    func onAdGratified(adConfig: AdConfig, withReward reward: Float)
    {
        testAdVC.onAdGratified(adConfig, withReward: reward);
    }
    
    
    
    func onAdSkipped(adConfig:AdConfig)
    {
        testAdVC.onAdSkipped(adConfig)
    }
    
    
    func onAdClosed(adConfig:AdConfig)
    {
        testAdVC.onAdClosed(adConfig)
    }
    
    
    func onAdAvailabilityStatus(adConfig: AdConfig, withAvailability isAdAvailable: Bool)
    {
        testAdVC.onAdAvailabilityStatus(adConfig, withAvailability: isAdAvailable)
        
    }
    
    
    func textFieldShouldReturn(textField: UITextField) -> Bool {   //delegate method
        textField.resignFirstResponder()
        return true
    }
    
    func showAlertWithMessage(msg:String) {
        let alert:UIAlertView = UIAlertView(title:"",message:msg,delegate:nil,cancelButtonTitle:"OK");
        alert.show()
    }
    
}