//
//  TestRewardedVC.swift
//  SwiftSample
//
//  Created by Pokkt on 21/03/16.
//  Copyright © 2016 Pokkt. All rights reserved.
//

import UIKit

class TestRewardedVC: UIViewController, AdDelegate
{

    internal var screenName : String?
    internal var isReward : Bool?
    
    @IBOutlet  var startCaching: UIButton?
    @IBOutlet  var playAdBtn: UIButton?
    
    @IBOutlet  var pointNumLbl: UILabel?
    
    let adConfig:AdConfig = AdConfig()
    
    let defaults = NSUserDefaults.standardUserDefaults()

    let ErnedPoints = "Points"
    
    var point : Float = 0
    
     override func viewDidLoad() {
        super.viewDidLoad()
        
         // Do any additional setup after loading the view.
    }

    override func didReceiveMemoryWarning() {
        super.didReceiveMemoryWarning()
        // Dispose of any resources that can be recreated.
    }
    
    override func viewWillAppear(animated: Bool) {
        NSNotificationCenter.defaultCenter().addObserver(self, selector: "showToast:", name: "toastMessage", object: nil)
        showButton(false)
        
        updatepointsEarned()
        setCornerRadius()
        
        self.adConfig.screenName = screenName;
        self.adConfig.isRewarded = isReward!;
        self.adConfig.shouldAllowSkip = true;
        self.adConfig.defaultSkipTime = 10;

    }
    
    func setCornerRadius()
    {
        startCaching?.layer.cornerRadius = 10; // this value vary as per your desire
        startCaching?.clipsToBounds = true;
        
        playAdBtn?.layer.cornerRadius = 10; // this value vary as per your desire
        playAdBtn?.clipsToBounds = true;
        
     }
    


        func updatepointsEarned() {
            if(defaults.objectForKey(ErnedPoints) != nil){
                point = defaults.objectForKey(ErnedPoints)!.floatValue
                pointNumLbl!.text = String(format:"Points earned : %.2f",self.point)
            }
        }
    
        func showButton(show:Bool) {
            
            playAdBtn?.hidden = false
            if (!show) {
                if (self.adConfig.isRewarded) {
                    playAdBtn?.setTitle("Play Rewarded Ad(Without Caching)", forState:UIControlState.Normal)
                    
                }
                else
                {
                     playAdBtn?.setTitle("Play NonRewarded Ad(Without Caching)", forState:UIControlState.Normal)
                }
                
            }
            else
            {
                if (self.adConfig.isRewarded) {
                     playAdBtn?.setTitle("Play Rewarded Ad(with Caching)", forState:UIControlState.Normal)
                    
                }
                else
                {
                    playAdBtn?.setTitle("Play NonRewarded Ad(with Caching)", forState:UIControlState.Normal)
                    
                }
                
            }

        }
    
        func showAlertWithMessage(msg:String) {
            let alert:UIAlertView = UIAlertView(title:"",message:msg,delegate:nil,cancelButtonTitle:"OK");
            alert.show()
        }
    
    
    
    @IBAction func videoButtonAction(sender: UIButton)
    {
       if(sender.tag == 1)
       {
        checkVideoCache()
        playAdBtn?.hidden = true
       }
        else if (sender.tag == 2)
       {
        PokktManager.checkAdAvailability(self.adConfig)
        }
        
    }
    
    func checkVideoCache()
    {
                PokktManager.cacheAd(self.adConfig)
    }
    
        func onPokktInitialised(isReady:Bool)
        {
            var msg: String
            if (isReady)
            {
               msg = "PokktSDK is ready";
            }
            else
            {
               msg = "PokktSDK is not ready";
    
            }
            
            showAlertWithMessage(msg)
        }
    
        func onAdCachingCompleted(adConfig: AdConfig, withReward reward: Float)
        {
            showButton(true)
           
        }
    
        func onAdCachingFailed(adConfig: AdConfig, withErrorMessage errorMessage: String)
        {
            var str : String
            str = "";
            if (adConfig.isRewarded) {
                str = "rewarded";
            }
            else
            {
                str = "non rewarded";
            }
    
            showButton(false)
           
    
           let msgStr = NSString(format:"%@ %@ ad not available", adConfig.screenName,str) as String
            showAlertWithMessage(msgStr)
        }
    
    
        func onAdCompleted(adConfig: AdConfig)
        {
            showAlertWithMessage("Video is completed")
        }
    
    
        func onAdDisplayed(adConfig:AdConfig)
        {
             self.navigationController?.navigationBarHidden = true
    
            showAlertWithMessage("Video is displayed")
        }
    
    
        func onAdGratified(adConfig: AdConfig, withReward reward: Float)
        {
            
            
            if(defaults.objectForKey(ErnedPoints) != nil){
                point = defaults.objectForKey(ErnedPoints)!.floatValue
            }
            if(reward > 0){
                point += reward
                defaults.setValue(String(format:"%.2f",self.point), forKey: ErnedPoints)
                defaults.synchronize()
                updatepointsEarned()
            }
        }
    
    
    
        func onAdSkipped(adConfig:AdConfig)
        {
            showAlertWithMessage("Video is skipped")
        }
    
    
        func onAdClosed(adConfig:AdConfig)
        {
            showButton(false)
            self.navigationController?.navigationBarHidden = false
            showAlertWithMessage("Video is closed")
        }
    
    
        func onAdAvailabilityStatus(adConfig: AdConfig, withAvailability isAdAvailable: Bool)
        {
            print("Ad is available")
            if (isAdAvailable)
            {

                PokktManager.showAd(self.adConfig,presentingViewController:self)
    
            }
            else
            {
                var str : String
                str = "";
                if (adConfig.isRewarded) {
                    str = "rewarded";
                }
                else
                {
                    str = "non rewarded";
                }
                
                let msgStr = NSString(format:"%@ %@ ad not available", adConfig.screenName,str) as String
                showAlertWithMessage(msgStr)
            }
     
        }
    
    func showToast(note: NSNotification)
    {
        let name: String = note.object! as! String
        [PokktManager.showToast(name, presentingViewController: self)];
    }
    

}
